var ListMenu = {
	data: null,
	length: 0,
	container: null,
	start: 0,
	playing: -1,
	selected: 0,
	center: 0,
	maxListMenuElements: 0,
	debugMode: false
};

ListMenu.log = function(m) {
	if (this.debugMode) {
		alert("ListMenu.js - " + m);
	} 
};

ListMenu.error = function(m) {
	if (this.debugMode) {
		alert("ListMenu.js - " + m);
	} 
};

ListMenu.init = function() { 
	this.data = $selectedShow.episodes;
	
	$('#SceneEpisodes').css('background-image','url('+$selectedShow.background+')');
	
	this.maxListMenuElements = 4;
	
	if (this.data.length < this.maxListMenuElements) {
		this.maxListMenuElements = this.data.length;
	}
	
    this.center = parseInt(this.maxListMenuElements / 2, 10);
    this.length = this.data.length;
    
    if (this.length < this.maxListMenuElements) {
    	this.maxListMenuElements = this.length;
    }

    if (parseInt(this.maxListMenuElements,10)%2 == 0) {
    	this.center--;
    }
	
    $('<h2>').attr('id','episodetitle').text($selectedShow.title).appendTo($('#episodescontent'));	
    
    $('#episodescontent').empty();
	this.container = $('<div>').attr('id','listmenu');
	this.container.appendTo($('#episodescontent'));	
	
	if (this.data.length > this.maxListMenuElements) {
		$('#listmenuscrollbar').show();
		$('#listmenuscrollbar').sfScroll({
			pages:this.length
		});	
	} else {
		$('#listmenuscrollbar').hide();
	}
	
	this.showMenu();

	return;
};

ListMenu.draw = function() {
	this.log("------------------------------------------------------------------------------ DRAW");
	this.container.empty();

	if ($selectedEpisode < this.center) { 
		this.log("------------------------------------------------------------------------------ 1");
		this.start = 0;
		$selectedEpisode = 0;
	} else if ($selectedEpisode >= this.length - this.center + (this.maxListMenuElements % 2 - 1)) {
		this.log("------------------------------------------------------------------------------ 2");
		this.start = this.length - this.maxListMenuElements;
	} else {
		this.log("------------------------------------------------------------------------------ 3");
		this.start = $selectedEpisode - this.center;
	}

	for (var v=0;v<this.maxListMenuElements;v++) {
		if ((v+this.start >= this.length) || (v+this.start < 0)){
			this.container.append(this.createEmptyItem(v));
		} else {
			this.container.append(this.createItem(v));
		}
	}

	this.log("------------------------------------------------------------------------------ SELECTED");
	this.log($selectedEpisode);
	this.log("------------------------------------------------------------------------------ /SELECTED");
	
	if (this.data.length > this.maxListMenuElements) {
		$('#listmenuscrollbar').sfScroll('move',$selectedEpisode);
	}
	
	this.onFocus();
};

ListMenu.moveToIdx = function(i) {
	if (i<0) i=0;

	if (i>this.length) i = this.length-1;

	$selectedEpisode = i;

	this.draw();
};

ListMenu.drawSingleElement = function(obj) {
	alert('_____________________________ DRAW SINGLE ITEM');
		
	var html = '';
	html += "<div class='wrap'>";
		html += "<div class='thumb'><img src='" + obj.icon + "' /></div>";
		html += "<div class='text'>";
			html += "<h3 class='title'>" + obj.title + "</h3>";
			html += "<p>" + obj.description + "</p>";
		html += "</div>";
	html += "</div>";
	
	return html;
};

ListMenu.createItem = function(i) {

	alert('_____________________________ CREATE ITEM');
	
	var obj = this.getInfo(i+this.start);

	var item = $('<div>', {
		'id':'nav_' + i,
		'class':'element',
	});

	if (i+this.start == $selectedEpisode) {
		item.addClass('selected');
	}

	item.html(this.drawSingleElement(obj));

	return item;
};

ListMenu.createEmptyItem = function(i) {
	
	var item = $('<div>', {
		'id':'nav_' + i,
		'class':'element',
	});

	item.addClass('empty');

	return item;
};

ListMenu.unfocus = function() {
  $('#element_' + $selectedEpisode).removeClass('selected');
};

ListMenu.focus = function() {
  $('#element_' + $selectedEpisode).addClass('selected');
};

ListMenu.showMenu = function() {
	this.draw();
};

ListMenu.onDown = function() {

    if ($selectedEpisode >= this.length-1) { 
      $selectedEpisode = 0; 
    } else {
      $selectedEpisode++;
    }

    this.draw();
};

ListMenu.onUp = function() {

    if ($selectedEpisode == 0) { 
      $selectedEpisode = this.length-1; 
    } else {
      $selectedEpisode--;
    }

    this.draw();

};

ListMenu.getInfo = function(id) {
	return this.data[id];
};

ListMenu.onFocus = function() { 
	ListMenu.log('FOCUS');
};

ListMenu.onEnter = function() {
	this.playing = $selectedEpisode;
	ListMenu.log('ENTER');

	$playlist = {
		url: this.data[$selectedEpisode].url,
		title: this.data[$selectedEpisode].title
	};		

	$returnscene = "Episodes";
	
	sf.scene.show('player');
	sf.scene.focus('player');	
};