alert('Sceneplayer.js loaded');

function Sceneplayer() {

};

Sceneplayer.prototype.initialize = function () {
	alert("Sceneplayer.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	
	var oSelf = this;
	
	sf.service.VideoPlayer.init({
		onerror: function(error) {
			switch (Number(error)) {
			case af.AVPLAY_UNSUPPORTED_CONTAINER_ERR:
			case af.AVPLAY_UNSUPPORTED_AUDIO_FORMAT_ERR:
			case af.AVPLAY_UNSUPPORTED_VIDEO_FORMAT_ERR:
			case af.AVPLAY_UNSUPPORTED_VIDEO_RESOLUTION_ERR:
			case af.AVPLAY_UNSUPPORTED_VIDEO_FRAMERATE_ERR:
				errorMessage = "Errore: il formato video non è valido. Non è possibile riprodurlo."; break;
			case af.AVPLAY_CURRUPTED_STREAM_ERR:
				errorMessage = "Errore: il video è danneggiato. Non è possibile riprodurlo."; break;
			case af.NOT_FOUND_ERR:
				errorMessage = "Errore: il video non è disponibile, riprovare più tardi."; break;
			case af.NETWORK_ERR:
				errorMessage = "Errore di rete: verificare il cavo di rete e la connessione e riprovare."; break;
			case af.NETWORK_SLOW_ERR:
				errorMessage = "Errore di rete: la connessione è troppo lenta per riprodurre questo contenuto."; break;
			case af.UNKNOWN_ERR:
			case af.CUSTOM_ERR:
			case af.SECURITY_ERR:
			default:
				errorMessage = "Errore generico, impossibile riprodurre il contenuto selezionato."; break;
			}
			
			$('#popupError').sfPopup({
				text: errorMessage,
				buttons:'OK',
				callback:function(rlt){
					sf.scene.hide('player');
					sf.scene.show($returnscene);
					sf.scene.focus($returnscene);	
					try {
						sf.service.VideoPlayer.stop();
					} catch(e) {
						alert(e);
					}
				}
			});
			$('#popupError').sfPopup('show');			
		},
		onend:function(){
			oSelf.doStop();
		}
	});

	var vLeft = parseInt($("#videoplayer").css('left'));
	var vTop = parseInt($("#videoplayer").css('top'));
	var vHeight = parseInt($("#videoplayer").css('height'));
	var vWidth = parseInt($("#videoplayer").css('width'));
	sf.service.VideoPlayer.setPosition({
		left:vLeft,
		top:vTop,
		width:vWidth,
		height:vHeight,
	});
	sf.service.VideoPlayer.show();
};

Sceneplayer.prototype.handleShow = function (data) {
	alert("Sceneplayer.handleShow()");
	// this function will be called when the scene manager show this scene
	
	sf.service.VideoPlayer.show();

	var oSelf = this;
	
	sf.service.VideoPlayer.setKeyHandler(sf.key.STOP, function () {
		oSelf.doStop();
	});	

	sf.service.VideoPlayer.setKeyHandler(sf.key.RETURN, function () {
		oSelf.doStop();
	});
	
	if ($playlist.url[0] === "r") {
		$playlist.liveStream = true;
	} else{
		$playlist.liveStream = false;
	}

	sf.service.VideoPlayer.play($playlist);
	sf.service.VideoPlayer.setFullScreen(true);
	
	if ($playlist.url[0] === "r") {
		sf.service.VideoPlayer.setKeyHelp({
		       'pause' : 'Pausa',
		       'play' : 'Play',
		       'enter' : 'Pausa/Play',
		       'tools' : 'Strumenti',
		       'stop' : 'Indietro'
		});		
	} else {
		sf.service.VideoPlayer.setKeyHelp({
		       'pause' : 'Pausa',
		       'play' : 'Play',
		       'rewff' : 'Avanti e indietro veloce',
		       'enter' : 'Pausa/Play',
		       'tools' : 'Strumenti',
		       'stop' : 'Indietro'
		});		
	}
	
};

Sceneplayer.prototype.doStop = function () { 
	if (sf.service.VideoPlayer.Skip.isInProgress()) {
		sf.service.VideoPlayer.Skip.cancel();
	}			
	
	try {
		sf.service.VideoPlayer.stop();
	} catch(e) {
		alert(e);
	}
	
	sf.scene.hide('player');
	sf.scene.show($returnscene);
	sf.scene.focus($returnscene);	
};

Sceneplayer.prototype.handleHide = function () {
	alert("Sceneplayer.handleHide()");
	// this function will be called when the scene manager hide this scene
	sf.service.VideoPlayer.stop();
	sf.service.VideoPlayer.hide();
};

Sceneplayer.prototype.handleFocus = function () {
	alert("Sceneplayer.handleFocus()");
	// this function will be called when the scene manager focus this scene
};

Sceneplayer.prototype.handleBlur = function () {
	alert("Sceneplayer.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
};

Sceneplayer.prototype.handleKeyDown = function (keyCode) {
	alert("Sceneplayer.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case sf.key.LEFT:
			break;
		case sf.key.RIGHT:
			break;
		case sf.key.UP:
			break;
		case sf.key.DOWN:
			break;
		case sf.key.ENTER:
			break;
		case sf.key.FF:
			if ($playlist.url[0] === "r") {
				sf.key.preventDefault();
				alert("Default prevented because it is live stream");
			}
			break;
		case sf.key.RW:
			if ($playlist.url[0] === "r") {
				sf.key.preventDefault();
				alert("Default prevented because it is live stream");
			}
			break;
		default:
			alert("handle default key event, key code(" + keyCode + ")");
			break;
	}
};
